
import os.path
import storm.locals as stm
import storm.exceptions as stme

import storm.database

import sqlitext

_db_name = 'packages.db'

class Store(object):
    def __init__(self, dbdir):
        self.dbdir = os.path.abspath(dbdir)
        if not os.path.isdir(self.dbdir):
            os.makedirs(self.dbdir)
        self.db_path = os.path.join(self.dbdir, _db_name)
        self.has_db = os.path.exists(self.db_path)
        self.db = self.__open_db(self.db_path)
        sqlitext.enable_extension(self.db,1)

    def __open_db(self,pathname):
	#db_url = 'sqlite:/:memory:'
	db_url = 'sqlite:' + pathname
	database = stm.create_database(db_url)
	store = stm.Store(database)
	return store

    def initialise(self):
	self.db.execute('''SELECT load_extension('./libcollate_debian.so')''')
	self.db.commit()

    def close(self):
	self.db.commit()
	self.db.close()


s = Store('./')
s.initialise()

